package de.uka.algo.GT3D;

import java.awt.AWTException;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.GraphicsConfiguration;
import java.awt.Point;
import java.awt.Robot;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.URL;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;

import javax.media.j3d.AlternateAppearance;
import javax.media.j3d.AmbientLight;
import javax.media.j3d.Appearance;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.ColoringAttributes;
import javax.media.j3d.DirectionalLight;
import javax.media.j3d.Group;
import javax.media.j3d.Material;
import javax.media.j3d.Shape3D;
import javax.media.j3d.SpotLight;
import javax.media.j3d.TexCoordGeneration;
import javax.media.j3d.Texture;
import javax.media.j3d.TextureAttributes;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.TransparencyAttributes;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.Timer;
import javax.vecmath.AxisAngle4d;
import javax.vecmath.AxisAngle4f;
import javax.vecmath.Color3f;
import javax.vecmath.Color4f;
import javax.vecmath.Matrix3d;
import javax.vecmath.Point3d;
import javax.vecmath.Point3f;
import javax.vecmath.Vector2d;
import javax.vecmath.Vector3d;
import javax.vecmath.Vector3f;

import y.base.Edge;
import y.base.EdgeCursor;
import y.base.EdgeMap;
import y.base.Node;
import y.base.NodeCursor;
import y.view.Graph2D;
import yext.graphml.graph2D.GraphMLIOHandler;

import com.sun.j3d.utils.geometry.Cone;
import com.sun.j3d.utils.geometry.Cylinder;
import com.sun.j3d.utils.geometry.Primitive;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.picking.PickCanvas;
import com.sun.j3d.utils.picking.PickResult;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.universe.ViewingPlatform;

public class FlyThroughGenreTime extends JFrame implements ActionListener, KeyListener, MouseMotionListener, MouseListener, MouseWheelListener {
	private Canvas3D c3d;

	private EdgeMap edgeWeights;

	private LinkedList<Edge> acceptedEdges;

	private JButton go = new JButton("Start");

	private JButton cameraInfo = new JButton("Camera Info");

	private JButton invertMouseY = new JButton("Invert Mouse (y)");

	private JButton steuerknueppelButton = new JButton("use mouse joystick-like");

	private JLabel messageLabel = new JLabel("");

	private JLabel coordLabel = new JLabel("");

	private double rotation = 0.0;
	private int currentPressedKey;
	private Timer timer;

	private int timerMillis = 20;

	boolean recordOn = false;

	boolean playOn = false;

	int tourCounter = 0;

	String navFile = "autopilot.txt";

	BufferedWriter statsWrite;

	BufferedReader statsRead;

	private TransformGroup flyingCamera = new TransformGroup();

	private Transform3D moveCamera = new Transform3D();

	private ViewingPlatform vPlatform;

	private PickCanvas pickCanvas;

	private BranchGroup scene;

	private Cylinder fireRay;

	private BranchGroup dynamicStuffBG;

	private BranchGroup dynamicParentGroup;

	private TransformGroup TGFire;

	private Transform3D T3DFire;

	private TransformGroup TGFireSub;

	private Transform3D T3DFireSub;

	private BoundingSphere headSpotlightBounds;

	private int aimTolerance = 22;

	private double lookSensitivity = 0.003;

	private double knueppelSensitivity = 0.02;

	private double moveSensitivity = 0.3;

	private double keyRollFactor = 30.0;

	private double mWheelRollFactor = 200.0;

	private boolean steuerKnueppelMode = true;

	private double edgeRelevancePercentageThreshold = 0.5;

	private double edgeRelevanceAbsoluteThreshold = 0;

	private int maxOutDegree = 2;

	private Matrix3d camHeading = new Matrix3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);

	private Vector3d camPosition = new Vector3d(0.0, 0.0, 20.0);

	private Matrix3d rotMatX = new Matrix3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0); // these will be modified according to mouse movement,
	// // then multiplied with camHeading

	private Matrix3d rotMatY = new Matrix3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);

	private Matrix3d rotMatZ = new Matrix3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);

	private Matrix3d unitMatrix3D = new Matrix3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);

	private Matrix3d rotMatYtoMinusZ = new Matrix3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);

	private Matrix3d startRotation = new Matrix3d(0.9986783280557308, 0.0035689514255241466, -0.05127240639502675, 0.001182416936916051, 0.9957267237888925, 0.09234117945324663, 0.051382866424537106, -0.09227976006878073, 0.9944064797252914);

	private Vector3d dazuPosition = new Vector3d(0.0, 0.0, 0.0);

	private Vector3d startPosition = new Vector3d(-7.59, 6.89, 86.30);

	private Vector3f tempRotAxis = new Vector3f(0.0f, 1.0f, 0.0f);

	double mX = 0.0; // for turning calculation

	double cosmX = 0.0;

	double sinmX = 0.0;

	double mY = 0.0;

	double cosmY = 0.0;

	double sinmY = 0.0;

	double mZ = 0.0;

	double cosmZ = 0.0;

	double sinmZ = 0.0;

	double refX = 0.0; // reference (last) coordinate for mouse movement
	// detection

	double refY = 0.0;

	Point canvasTopLeft;

	double Ysign = -1.0; // -1 means invertY, 1 means arcade

	static Robot theRobot;

	static int resolutionX = 1000; // MainFrame Resolution

	static int resolutionY = 700;

	float tubeLength = 60.0f; // Länge des Zeitschlauches

	float tubeRadius = 5.0f; // Radius des Zeitschlauches

	double tubeTransparency = 0.1; // kla

	boolean tubeTextureOn = false;

	boolean nodeTextureOn = true;

	int xDivision = 30;

	int yDivision = 1;

	// String sourceGraphString =
	// "/home/rgoerke/Beispielgraphen/ZacharysKarateClub.graphml";
	// String sourceGraphString =
	// "/export/home/i11pc215/robert/Beispielgraphen/ZacharysKarateClub.graphml";
	// String sourceGraphString =
	// "/export/home/i11pc215/robert/workspace/GDcontests/resource/genreTransitionLayouted.graphml";
	String sourceGraphString = "resource/genreTimeTransition5.graphml";

	// String sourceGraphString =
	// "/export/home/i11pc215/robert/workspace/GDcontests/resource/genreTimeTransition10.graphml.bz2";
	boolean graphIsDirected = true;

	boolean restrictArrowCones = true;

	boolean graphEdgesAreWeighted = true;

	boolean inWeightRelevant = false;

	boolean graphNodeWidthRelevant = true;

	Map<Node, Sphere> nodeToSphere;

	Map<Sphere, Node> sphereToNode;

	Map<Node, Vector3f> nodeToLocation;

	Map<Node, Double> nodeToInWeight;

	Map<Edge, Cylinder> edgeToCylinder;

	Map<Edge, Cone> edgeToCone;

	Set<HeadSet> allHeads;

	int headPrimflags = Primitive.GENERATE_NORMALS + Primitive.GENERATE_TEXTURE_COORDS;

	ColoringAttributes nodeSphereColoringAttributes = new ColoringAttributes();

	ColoringAttributes axisColoringAttributes = new ColoringAttributes();

	ColoringAttributes edgeColoringAttributes = new ColoringAttributes();

	ColoringAttributes tubeColoringAttributes = new ColoringAttributes();

	ColoringAttributes fireRayColoringAttributes = new ColoringAttributes();

	ColoringAttributes headColoringAttributes = new ColoringAttributes();

	Material axisMaterial;

	Material edgeMaterial;

	Material tubeMaterial;

	Material fireRayMaterial;

	Material boomMaterial;

	Material headMaterial;

	Appearance boomAppearance = new Appearance();

	AlternateAppearance pickAppearance = new AlternateAppearance();

	// Set up colors
	Color3f black = new Color3f(0.0f, 0.0f, 0.0f);

	Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

	Color3f red = new Color3f(1.0f, .0f, .0f);

	Color3f lightred = new Color3f(1.0f, .85f, .8f);

	Color3f blue = new Color3f(0.0f, 0.0f, 1.0f);

	Color3f lightblue = new Color3f(0.25f, 0.25f, .5f);

	Color3f darkblue = new Color3f(.0f, 0.0f, .3f);

	Color3f yellow = new Color3f(1.0f, 1.0f, .0f);

	Color3f darkyellow = new Color3f(.6f, .6f, .0f);

	Color3f lightyellow = new Color3f(0.9f, 0.9f, .65f);

	Color3f orange = new Color3f(1.0f, 0.5f, .0f);

	Color3f green = new Color3f(0.0f, 1.0f, .0f);

	Color3f darkgreen = new Color3f(0.0f, 0.5f, .0f);

	Color3f lightgreen = new Color3f(0.8f, 1.0f, .8f);

	Color3f brown = new Color3f(0.9f, 0.6f, .0f);

	Color3f darkgray = new Color3f(0.3f, 0.3f, .3f);

	Color3f lightgray = new Color3f(0.7f, 0.7f, .7f);

	Color3f darkergray = new Color3f(0.2f, 0.2f, .2f);

	Material nodeSphereMaterial = new Material(black, darkyellow, white, black, 16.0f);

	// ambient, diffuse, specular, emisssive, shininess
	Material adultNodeSphereMaterial = new Material(black, darkblue, white, black, 16.0f);

	Material musicNodeSphereMaterial = new Material();

	Material comedyNodeSphereMaterial = new Material();

	Material familyNodeSphereMaterial = new Material();

	Material dramaNodeSphereMaterial = new Material();

	Material thrillerNodeSphereMaterial = new Material();

	Material crimeNodeSphereMaterial = new Material();

	Material animationNodeSphereMaterial = new Material();

	Material warNodeSphereMaterial = new Material();

	Material adventureNodeSphereMaterial = new Material();

	Material actionNodeSphereMaterial = new Material();

	Material mysteryNodeSphereMaterial = new Material();

	Material musicalNodeSphereMaterial = new Material();

	Material romanceNodeSphereMaterial = new Material();

	Material fantasyNodeSphereMaterial = new Material();

	Material scifiNodeSphereMaterial = new Material();

	Material westernNodeSphereMaterial = new Material();

	Material horrorNodeSphereMaterial = new Material();

	Material filmnoirNodeSphereMaterial = new Material();

	public BranchGroup createSceneGraph() {

		nodeSphereColoringAttributes.setColor(darkyellow);
		axisColoringAttributes.setColor(darkgray);
		edgeColoringAttributes.setColor(darkgray);
		tubeColoringAttributes.setColor(darkgray);
		fireRayColoringAttributes.setColor(red);

		// ambient, diffuse, specular, emisssive, shininess
		axisMaterial = new Material(black, darkgray, white, black, 4.0f);
		// edgeMaterial = new Material(black, darkgreen, white, black, 32.0f);
		edgeMaterial = new Material(black, darkgreen, lightgray, black, 4.0f);
		// tubeMaterial = new Material(black, black, lightgray, black, 1.0f);
		tubeMaterial = new Material(black, black, darkgray, black, 1.0f);
		fireRayMaterial = new Material(black, black, lightgray, red, 1.0f);
		headMaterial = new Material(black, lightgray, white, black, 1.0f);

		boomMaterial = new Material(white, white, lightgray, black, 1.0f);
		boomAppearance.setColoringAttributes(nodeSphereColoringAttributes);
		boomAppearance.setMaterial(boomMaterial);
		pickAppearance.setAppearance(boomAppearance);

		// Create the root of the branch graph
		BranchGroup objRoot = new BranchGroup();
		// Set up the lights
		createLight(objRoot);
		// set up BaseTube
	createBaseTube(objRoot);
		// set up Coordinate System
		createCoordinateSystem(objRoot);
		// read the Graph....
		Graph2D sourceGraph = readSourceGraph();
		// ...and imprint it onto the surface of the Cylinder
	imprintSourceGraph(sourceGraph, objRoot);
		// add some nonsense
	createFamousHeads(objRoot, sourceGraph);
		// add test nonsense
		//createNonsense(objRoot);

		return objRoot;
	}

	private void createNonsense(BranchGroup objRoot) {
		   Sphere sphere = new Sphere(0.5f);
		   objRoot.addChild(sphere);
		
	}

	private void createFamousHeads(BranchGroup objRoot, Graph2D sourceGraph) {

		allHeads = new HashSet<HeadSet>(10); // should be increased !
		float headLength = 0.6f;
		float headRadius = 0.4f;

		for (NodeCursor nc = sourceGraph.nodes(); nc.ok(); nc.next()) {

			if (sourceGraph.getLabelText(nc.node()).contains("Drama_1999")) {
				// sourceGraph, scene, pathToTexture, radius, length,
				// positionNode, rotationspeed
				HeadSet myHead = new HeadSet(sourceGraph, objRoot, FlyThroughGenreTime.class.getResource("resource/famousHeads/Drama1998_horsewhisp.jpg"), headRadius, headLength, nc.node(), 1f);
				allHeads.add(myHead);
			}

			if (sourceGraph.getLabelText(nc.node()).contains("Western_1992")) {
				HeadSet myHead = new HeadSet(sourceGraph, objRoot, FlyThroughGenreTime.class.getResource("resource/famousHeads/western1992.jpg"), headRadius, headLength, nc.node(), 1f);
				allHeads.add(myHead);
			}

			if (sourceGraph.getLabelText(nc.node()).contains("Animation_1990")) {
				HeadSet myHead = new HeadSet(sourceGraph, objRoot, FlyThroughGenreTime.class.getResource("resource/famousHeads/animation19XX_Bart.jpg"), headRadius, headLength, nc.node(), 1f);
				allHeads.add(myHead);
			}

			if (sourceGraph.getLabelText(nc.node()).contains("Fantasy_1984")) {
				HeadSet myHead = new HeadSet(sourceGraph, objRoot, FlyThroughGenreTime.class.getResource("resource/famousHeads/fantasy1984_momo.jpg"), headRadius, headLength, nc.node(), 1f);
				allHeads.add(myHead);
			}

			if (sourceGraph.getLabelText(nc.node()).contains("Crime_1989")) {
				HeadSet myHead = new HeadSet(sourceGraph, objRoot, FlyThroughGenreTime.class.getResource("resource/famousHeads/crime1989.jpg"), headRadius, headLength, nc.node(), 1f);
				allHeads.add(myHead);
			}

			if (sourceGraph.getLabelText(nc.node()).contains("Comedy_2001")) {
				HeadSet myHead = new HeadSet(sourceGraph, objRoot, FlyThroughGenreTime.class.getResource("resource/famousHeads/comedy2001_amelie.jpg"), headRadius, headLength, nc.node(), 1f);
				allHeads.add(myHead);
			}

			if (sourceGraph.getLabelText(nc.node()).contains("Action_1984")) {
				HeadSet myHead = new HeadSet(sourceGraph, objRoot, FlyThroughGenreTime.class.getResource("resource/famousHeads/Action1984_T1.jpg"), headRadius, headLength, nc.node(), 1f);
				allHeads.add(myHead);
			}

			if (sourceGraph.getLabelText(nc.node()).contains("Crime_1998")) {
				HeadSet myHead = new HeadSet(sourceGraph, objRoot, FlyThroughGenreTime.class.getResource("resource/famousHeads/Crime1998_OutOfSight.jpg"), headRadius, headLength, nc.node(), 1f);
				allHeads.add(myHead);
			}

			if (sourceGraph.getLabelText(nc.node()).contains("Romance_1990")) {
				HeadSet myHead = new HeadSet(sourceGraph, objRoot, FlyThroughGenreTime.class.getResource("resource/famousHeads/romance1990_prettywoman.jpg"), headRadius, headLength, nc.node(), 1f);
				allHeads.add(myHead);
			}

			if (sourceGraph.getLabelText(nc.node()).contains("Adventure_2003")) {
				HeadSet myHead = new HeadSet(sourceGraph, objRoot, FlyThroughGenreTime.class.getResource("resource/famousHeads/Adventure2003_cradleoflife.jpg"), headRadius, headLength, nc.node(), 1f);
				allHeads.add(myHead);
			}
		}
	}

	public class HeadSet {
		protected Cylinder theHead;

		protected TransformGroup headTransGroup;

		protected Transform3D headTrans3D;

		protected TransformGroup headPostTransGroup;

		protected Transform3D headPostTrans3D;

		protected Vector3f headPosi;

		protected AxisAngle4f headPreRotation;

		protected AxisAngle4f headPostRotation;

		protected SpotLight headSpotLight;

		protected Color3f headSpotLightColor;

		protected Point3f headSpotLightPosition;

		protected Vector3f headSpotLightDirection;

		protected float spreadAngle;

		protected float concentration;

		protected float rotSpeed;

		public HeadSet(Graph2D sourceGraph, BranchGroup objRoot, URL texturePath, float headRadius, float headLength, Node referenceNode, float rotationSpeed) {

			Vector3f headPosition = new Vector3f(nodeToLocation.get(referenceNode)); // =referenceNode;
			headPosition.x = 0.0f;
			headPosition.scale(1f + (nodeToSphere.get(referenceNode).getRadius() + headLength / 2.0f) / headPosition.length() * 1.1f);
			headPosition.x = nodeToLocation.get(referenceNode).x;

			Appearance headAppearance = new Appearance();
			// Set up the texture map
			TextureLoader textureLoader = new TextureLoader(texturePath, "RGB", new Container());
			Texture texture = textureLoader.getTexture();
			texture.setBoundaryModeS(Texture.WRAP);
			texture.setBoundaryModeT(Texture.WRAP);
			texture.setBoundaryColor(new Color4f(0.0f, 1.0f, 0.0f, 0.0f));
			// Set up the texture attributes, could be REPLACE, BLEND or DECAL
			// instead of MODULATE
			TextureAttributes texAttr = new TextureAttributes();
			texAttr.setTextureMode(TextureAttributes.MODULATE);
			headAppearance.setTexture(texture);
			headAppearance.setMaterial(headMaterial);
			headAppearance.setTextureAttributes(texAttr);
			// set up the material
			headColoringAttributes.setShadeModel(ColoringAttributes.NICEST);
			headAppearance.setColoringAttributes(headColoringAttributes);
			headAppearance.setMaterial(headMaterial);
			// create the Head and move it
			theHead = new Cylinder(headRadius, headLength, headPrimflags, headAppearance);
			headTransGroup = new TransformGroup();
			headTrans3D = new Transform3D();
			headPostTransGroup = new TransformGroup();
			headPostTrans3D = new Transform3D();
			headPreRotation = new AxisAngle4f(new Vector3f(1.0f, .0f, .0f), (float) (Math.atan(headPosition.z / headPosition.y)));
			headPostRotation = new AxisAngle4f(new Vector3f(0.0f, headPosition.y, headPosition.z), 0f);
			rotSpeed = rotationSpeed;
			headPosi = new Vector3f(headPosition);
			headTrans3D.setTranslation(headPosi);
			headTrans3D.setRotation(headPreRotation);
			headPostTrans3D.setRotation(headPostRotation);
			headTransGroup.setTransform(headTrans3D);
			headPostTransGroup.setTransform(headPostTrans3D);
			headPostTransGroup.addChild(theHead);
			headTransGroup.addChild(headPostTransGroup);
			objRoot.addChild(headTransGroup);
			headPostTransGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);

			// spotlight the head!
			headSpotLightColor = white;
			headSpotLightPosition = new Point3f(headPosi.x, headPosi.y * 1.2f, headPosi.z * 1.2f);
			headSpotLightDirection = new Vector3f(0.0f, -headPosi.y, -headPosi.z);
			spreadAngle = (float) (Math.PI / 8.0);
			concentration = 0.0f;
			Point3f attenuation = new Point3f(1.0f, 1.0f, 1.0f);
			headSpotLight = new SpotLight(true, headSpotLightColor, headSpotLightPosition, attenuation, headSpotLightDirection, spreadAngle, concentration);
			headSpotLight.setInfluencingBounds(headSpotlightBounds);
			objRoot.addChild(headSpotLight);
			headSpotLight.setCapability(javax.media.j3d.Light.ALLOW_STATE_WRITE);
		}
	}

	private Graph2D readSourceGraph() {
		Graph2D inputGraph = new Graph2D();
		edgeWeights = inputGraph.createEdgeMap();

		try {

			new GraphMLIOHandler().read(inputGraph, FlyThroughGenreTime.class.getResource(sourceGraphString));
		} catch (IOException ioe) {
			System.out.println("(EE) " + ioe);
		}

		for (EdgeCursor ec = inputGraph.edges(); ec.ok(); ec.next()) {
			double w = Double.parseDouble(inputGraph.getLabelText(ec.edge()));
			// w = Math.log(w*w);
			edgeWeights.setDouble(ec.edge(), w);
			// inputGraph.setLabelText(ec.edge(), w));
		}

		acceptedEdges = new LinkedList<Edge>();

		for (NodeCursor nc = inputGraph.nodes(); nc.ok(); nc.next()) {
			Edge[] outEdges = new Edge[nc.node().outDegree()];
			int i = 0;
			for (EdgeCursor ec = nc.node().outEdges(); ec.ok(); ec.next(), i++) {
				outEdges[i] = ec.edge();
			}
			Arrays.sort(outEdges, new Comparator<Edge>() {
				public int compare(Edge o1, Edge o2) {
					Graph2D g = (Graph2D) o1.getGraph();
					double diff = Double.parseDouble(g.getLabelText(o2)) - Double.parseDouble(g.getLabelText(o1));
					return diff < 0 ? -1 : 1;
				}
			});
			for (i = 0; i < maxOutDegree && i < outEdges.length; i++) {
				double w = Double.parseDouble(inputGraph.getLabelText(outEdges[i]));
				if (w < 1)
					continue;
				acceptedEdges.add(outEdges[i]);
			}
		}

		return (inputGraph);
	}

	private void imprintSourceGraph(Graph2D sourceGraph, BranchGroup objRoot) {
		double maxX = sourceGraph.getCenterX(sourceGraph.nodes().node());
		double minX = sourceGraph.getCenterX(sourceGraph.nodes().node());
		double maxY = sourceGraph.getCenterY(sourceGraph.nodes().node());
		double minY = sourceGraph.getCenterY(sourceGraph.nodes().node());

		// double maxR = sourceGraph.nodes().node().inDegree(); // always <=
		// maxDegree or maxInDegree
		// double minR = sourceGraph.nodes().node().degree(); // always >=
		// minDegree or minInDegree
		double maxR = sourceGraph.getWidth(sourceGraph.nodes().node());
		double minR = sourceGraph.getWidth(sourceGraph.nodes().node());

		double minW = 0.0;
		double maxW = 0.0;
		double circumferentialRange = 0.0f;
		double circumferentialOffset = 0.0f;
		float longitudinalRange = 0.0f;
		float longitudinalOffset = 0.0f;
		float nodeThicknessRange = 0.0f;
		float nodeThicknessOffset = 0.0f;
		Node currentNode = null;
		Node currentSource = null;
		Node currentTarget = null;
		float currentNodeX = 0.0f;
		float currentNodeY = 0.0f;
		float currentNodeZ = 0.0f;
		float currentNodeRadius = 0.0f;
		float currentEdgeThickness = 0.0f;
		float edgeThicknessRange = 0.0f;
		float edgeThicknessOffset = 0.0f;

		// ----------------------------------------------------------------------Nodes--------------------------------------------------------
		// collect node extremes for scaling purposes;
		double thisNodeThickness = 0.0;

		nodeToInWeight = new HashMap<Node, Double>(sourceGraph.N());

		for (NodeCursor nc = sourceGraph.nodes(); nc.ok(); nc.next()) {
			currentNode = nc.node();
			if (sourceGraph.getCenterX(currentNode) > maxX)
				maxX = sourceGraph.getCenterX(currentNode);
			if (sourceGraph.getCenterX(currentNode) < minX)
				minX = sourceGraph.getCenterX(currentNode);
			if (sourceGraph.getCenterY(currentNode) > maxY)
				maxY = sourceGraph.getCenterY(currentNode);
			if (sourceGraph.getCenterY(currentNode) < minY)
				minY = sourceGraph.getCenterY(currentNode);

			if (inWeightRelevant) {
				thisNodeThickness = 0.0;
				for (EdgeCursor ec = currentNode.inEdges(); ec.ok(); ec.next()) {
					thisNodeThickness += Double.parseDouble(sourceGraph.getLabelText(ec.edge()));
				}
				nodeToInWeight.put(currentNode, thisNodeThickness);
				if (thisNodeThickness > maxR)
					maxR = thisNodeThickness;
				if (thisNodeThickness < minR)
					minR = thisNodeThickness;
			} else {
				if (graphIsDirected && (!graphNodeWidthRelevant)) {
					if (currentNode.inDegree() > maxR)
						maxR = currentNode.inDegree();
					if (currentNode.inDegree() < minR)
						minR = currentNode.inDegree();
				} else {
					if (currentNode.degree() > maxR)
						maxR = currentNode.degree();
					if (currentNode.degree() < minR)
						minR = currentNode.degree();
				}
			}

			if (graphNodeWidthRelevant) {
				if (sourceGraph.getWidth(currentNode) > maxR)
					maxR = sourceGraph.getWidth(currentNode);
				if (sourceGraph.getWidth(currentNode) < minR)
					minR = sourceGraph.getWidth(currentNode);
				nodeToInWeight.put(currentNode, thisNodeThickness);
			}
		}

		circumferentialRange = (Math.PI * 2.0f * 17.0 / 18.0) / (maxY - minY);
		circumferentialOffset = -1.0 * circumferentialRange * minY; // start,...
		// somewhere
		longitudinalRange = (tubeLength - 1.0f) / (float) (maxX - minX);
		longitudinalOffset = -0.5f * tubeLength + 0.5f; // start almost at left
		// end of Tube
		nodeThicknessRange = 1.35f / (float) (maxR - minR);
		nodeThicknessOffset = 0.25f; // TODO

		sphereToNode = new HashMap<Sphere, Node>(sourceGraph.N());
		nodeToSphere = new HashMap<Node, Sphere>(sourceGraph.N());
		nodeToLocation = new HashMap<Node, Vector3f>(sourceGraph.N());
		// ---------------------------------------------------------------------------------------------GENRE-TEXTUREN-----------------------------------------
		// TextureLoader romanceNodeTextureLoader = new
		// TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/RobertRedford.jpg",
		// "LUMINANCE", new Container());
		TextureLoader romanceNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/romance.jpeg"), "RGB", new Container());
		// mipMapMode, format, width, height
		Texture romanceNodeTexture = romanceNodeTextureLoader.getTexture();
		// romanceNodeTexture.setBoundaryModeS(Texture.CLAMP);
		// romanceNodeTexture.setBoundaryModeT(Texture.CLAMP);
		// romanceNodeTexture.setBoundaryColor(new Color4f(0.0f, 1.0f, 0.0f,
		// 0.0f));

		TextureLoader adultNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/adult.jpg"), "RGB", new Container());
		Texture adultNodeTexture = adultNodeTextureLoader.getTexture();

		TextureLoader westernNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/western.jpg"), "RGB", new Container());
		Texture westernNodeTexture = westernNodeTextureLoader.getTexture();

		TextureLoader horrorNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/horror.jpg"), "RGB", new Container());
		Texture horrorNodeTexture = horrorNodeTextureLoader.getTexture();

		TextureLoader warNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/war.jpg"), "RGB", new Container());
		Texture warNodeTexture = warNodeTextureLoader.getTexture();

		TextureLoader scifiNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/scifi.jpg"), "RGB", new Container());
		Texture scifiNodeTexture = scifiNodeTextureLoader.getTexture();

		TextureLoader musicNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/music.jpg"), "RGB", new Container());
		Texture musicNodeTexture = musicNodeTextureLoader.getTexture();

		TextureLoader comedyNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/comedy.jpg"), "RGB", new Container());
		Texture comedyNodeTexture = comedyNodeTextureLoader.getTexture();

		TextureLoader familyNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/family.jpg"), "RGB", new Container());
		Texture familyNodeTexture = familyNodeTextureLoader.getTexture();

		TextureLoader dramaNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/drama.jpg"), "RGB", new Container());
		Texture dramaNodeTexture = dramaNodeTextureLoader.getTexture();

		TextureLoader thrillerNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/thriller.jpg"), "RGB", new Container());
		Texture thrillerNodeTexture = thrillerNodeTextureLoader.getTexture();

		TextureLoader crimeNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/crime.jpg"), "RGB", new Container());
		Texture crimeNodeTexture = crimeNodeTextureLoader.getTexture();

		TextureLoader mysteryNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/mystery.jpg"), "RGB", new Container());
		Texture mysteryNodeTexture = mysteryNodeTextureLoader.getTexture();

		TextureLoader fantasyNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/fantasy.jpg"), "RGB", new Container());
		Texture fantasyNodeTexture = fantasyNodeTextureLoader.getTexture();

		TextureLoader animationNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/animation.jpg"), "RGB", new Container());
		Texture animationNodeTexture = animationNodeTextureLoader.getTexture();

		TextureLoader adventureNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/adventure.jpg"), "RGB", new Container());
		Texture adventureNodeTexture = adventureNodeTextureLoader.getTexture();

		TextureLoader musicalNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/musical.jpg"), "RGB", new Container());
		Texture musicalNodeTexture = musicalNodeTextureLoader.getTexture();

		TextureLoader filmnoirNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/filmnoir.jpg"), "RGB", new Container());
		Texture filmnoirNodeTexture = filmnoirNodeTextureLoader.getTexture();

		TextureLoader actionNodeTextureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/action.jpg"), "RGB", new Container());
		Texture actionNodeTexture = actionNodeTextureLoader.getTexture();

		TextureAttributes nodeTexAttr = new TextureAttributes();
		// nodeSphereAppearance.setMaterial(headMaterial);
		nodeTexAttr.setTextureMode(TextureAttributes.REPLACE);
		// could be REPLACE, BLEND or DECAL instead of MODULATE
		// ----------------------------------------------------------------------------------------ENDE-GENRE-TEXTUREN-----------------------------------------
		TexCoordGeneration nodeSphereTextCoord = new TexCoordGeneration(TexCoordGeneration.SPHERE_MAP, TexCoordGeneration.TEXTURE_COORDINATE_3);
		int yearOfNode = 0;
		for (NodeCursor nc = sourceGraph.nodes(); nc.ok(); nc.next()) {
			currentNode = nc.node();

			Appearance nodeSphereAppearance = new Appearance();
			nodeSphereColoringAttributes.setShadeModel(ColoringAttributes.NICEST);
			nodeSphereAppearance.setColoringAttributes(nodeSphereColoringAttributes);
			nodeSphereAppearance.setMaterial(nodeSphereMaterial);
			nodeSphereAppearance.setTextureAttributes(nodeTexAttr);
			nodeSphereAppearance.setTexCoordGeneration(nodeSphereTextCoord);

			// Set up the texture map
			yearOfNode = Integer.parseInt(sourceGraph.getLabelText(nc.node()).substring(sourceGraph.getLabelText(nc.node()).length() - 4));
			if (nodeTextureOn && (((yearOfNode / 5) * 5) >= yearOfNode)) {
				if (sourceGraph.getLabelText(nc.node()).contains("Romance"))
					nodeSphereAppearance.setTexture(romanceNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Adult"))
					nodeSphereAppearance.setTexture(adultNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Western"))
					nodeSphereAppearance.setTexture(westernNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("War"))
					nodeSphereAppearance.setTexture(warNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Sci-Fi"))
					nodeSphereAppearance.setTexture(scifiNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Horror"))
					nodeSphereAppearance.setTexture(horrorNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Music_"))
					nodeSphereAppearance.setTexture(musicNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Comedy"))
					nodeSphereAppearance.setTexture(comedyNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Family"))
					nodeSphereAppearance.setTexture(familyNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Drama"))
					nodeSphereAppearance.setTexture(dramaNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Thriller"))
					nodeSphereAppearance.setTexture(thrillerNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Crime"))
					nodeSphereAppearance.setTexture(crimeNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Mystery"))
					nodeSphereAppearance.setTexture(mysteryNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Fantasy"))
					nodeSphereAppearance.setTexture(fantasyNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Animation"))
					nodeSphereAppearance.setTexture(animationNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Adventure"))
					nodeSphereAppearance.setTexture(adventureNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Musical"))
					nodeSphereAppearance.setTexture(musicalNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("FilmNoir"))
					nodeSphereAppearance.setTexture(filmnoirNodeTexture);
				if (sourceGraph.getLabelText(nc.node()).contains("Action"))
					nodeSphereAppearance.setTexture(actionNodeTexture);
			}

			// if (sourceGraph.getLabelText(nc.node()).contains("Action"))
			// {nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);System.out.println("Action");}
			if (sourceGraph.getLabelText(nc.node()).contains("Adult"))
				nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			// if (sourceGraph.getLabelText(nc.node()).contains("Adventure"))
			// nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			if (sourceGraph.getLabelText(nc.node()).contains("Animation"))
				nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			// if (sourceGraph.getLabelText(nc.node()).contains("Comedy"))
			// nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			if (sourceGraph.getLabelText(nc.node()).contains("Crime"))
				nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			// if (sourceGraph.getLabelText(nc.node()).contains("Drama"))
			// nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			if (sourceGraph.getLabelText(nc.node()).contains("Family"))
				nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			// if (sourceGraph.getLabelText(nc.node()).contains("Fantasy"))
			// nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			if (sourceGraph.getLabelText(nc.node()).contains("Film-Noir"))
				nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			if (sourceGraph.getLabelText(nc.node()).contains("Horror"))
				nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			// if (sourceGraph.getLabelText(nc.node()).contains("Music_"))
			// nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			if (sourceGraph.getLabelText(nc.node()).contains("Musical"))
				nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			// if (sourceGraph.getLabelText(nc.node()).contains("Mystery"))
			// nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			if (sourceGraph.getLabelText(nc.node()).contains("Romance"))
				nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			// if (sourceGraph.getLabelText(nc.node()).contains("Sci-Fi"))
			// nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			if (sourceGraph.getLabelText(nc.node()).contains("Thriller"))
				nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			// if (sourceGraph.getLabelText(nc.node()).contains("War"))
			// nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			if (sourceGraph.getLabelText(nc.node()).contains("Western"))
				nodeSphereAppearance.setMaterial(adultNodeSphereMaterial);
			// System.out.println(sourceGraph.getLabelText(nc.node()));

			// --------------------------------------------------------Thickness----------------------------------------------------------------------
			if (inWeightRelevant)
				thisNodeThickness = nodeToInWeight.get(currentNode);
			else if (graphIsDirected && (!graphNodeWidthRelevant))
				thisNodeThickness = currentNode.inDegree();
			else
				thisNodeThickness = currentNode.degree();
			if (graphNodeWidthRelevant)
				thisNodeThickness = sourceGraph.getWidth(currentNode);

			currentNodeRadius = nodeThicknessOffset + (float) (thisNodeThickness - minR) * nodeThicknessRange;
			currentNodeX = longitudinalOffset + longitudinalRange * ((float) sourceGraph.getCenterX(currentNode) - (float) minX);
			currentNodeY = tubeRadius * (float) (Math.sin(circumferentialOffset + (sourceGraph.getCenterY(currentNode) - minY) * circumferentialRange));
			currentNodeZ = tubeRadius * (float) (Math.cos(circumferentialOffset + (sourceGraph.getCenterY(currentNode) - minY) * circumferentialRange));
			// -----------------------------------------------------ENDThickness-----------------------------------------------------------------------

			// create the nodeSphere and attach it
			Sphere currentNodeSphere = new Sphere(currentNodeRadius, headPrimflags, nodeSphereAppearance);
			TransformGroup currentNodeTG = new TransformGroup();
			Transform3D currentNodeTrans3D = new Transform3D();
			Vector3f currentNodeTranslation = new Vector3f(currentNodeX, currentNodeY, currentNodeZ);
			currentNodeTrans3D.setTranslation(currentNodeTranslation);
			// currentNodeTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
			currentNodeSphere.setCapability(Sphere.ENABLE_APPEARANCE_MODIFY);
			currentNodeTG.setTransform(currentNodeTrans3D);
			currentNodeTG.addChild(currentNodeSphere);
			objRoot.addChild(currentNodeTG);
			// System.out.println(sourceGraph.getLabelText(currentNode) + "
			// +texture " +
			// currentNodeSphere.getAppearance().getTextureUnitCount());
			// System.out.println("A node!");
			// System.out.println("added a Node at " + currentNodeTranslation+ "
			// with size " + currentNodeRadius);
			nodeToSphere.put(currentNode, currentNodeSphere);
			sphereToNode.put(currentNodeSphere, currentNode);
			nodeToLocation.put(currentNode, currentNodeTranslation);
		}

		// --------------------------------------------------------EDGES------------------------------------------------------------------

		if (graphEdgesAreWeighted) {
			minW = Double.parseDouble(sourceGraph.getLabelText(acceptedEdges.getFirst()));
			maxW = minW;
			double currentWeight = 0.0;
			for (Edge e : acceptedEdges) {
				currentSource = e.source();
				currentTarget = e.target();
				// double sourceNodeCard =
				// sourceGraph.getWidth(currentSource)*sourceGraph.getWidth(currentSource);
				// double targetNodeCard =
				// sourceGraph.getWidth(currentTarget)*sourceGraph.getWidth(currentTarget);
				// double minIncidentNodeCard = Math.min(targetNodeCard,
				// sourceNodeCard);
				if (currentTarget.equals(currentSource))
					continue;
				currentWeight = Double.parseDouble(sourceGraph.getLabelText(e));
				// if (Math.pow(currentWeight,2.0) <= minIncidentNodeCard *
				// edgeRelevancePercentageThreshold)
				// continue;
				// if ((currentWeight < (float) edgeRelevancePercentageThreshold
				// * nodeToInWeight.get(currentSource)) && (currentWeight <
				// (float) edgeRelevancePercentageThreshold *
				// nodeToInWeight.get(currentTarget))) continue;
				if (minW > currentWeight)
					minW = currentWeight;
				if (maxW < currentWeight)
					maxW = currentWeight;
			}
			edgeThicknessRange = 0.45f / (float) (maxW - minW); // TODO
			edgeThicknessOffset = 0.01f;
		}

		edgeToCylinder = new HashMap<Edge, Cylinder>(sourceGraph.E());
		if (graphIsDirected)
			edgeToCone = new HashMap<Edge, Cone>(sourceGraph.E());

		boolean tooThin = false;

		for (Edge e : acceptedEdges) {
			currentSource = e.source();
			// double sourceNodeCard =
			// sourceGraph.getWidth(currentSource)*sourceGraph.getWidth(currentSource);
			currentTarget = e.target();
			// double targetNodeCard =
			// sourceGraph.getWidth(currentTarget)*sourceGraph.getWidth(currentTarget);
			// double minIncidentNodeCard = Math.min(targetNodeCard,
			// sourceNodeCard);
			tooThin = false;
			if (currentTarget.equals(currentSource))
				continue;
			if (graphEdgesAreWeighted) { // das uebliche verfahren
				currentEdgeThickness = edgeThicknessOffset + edgeThicknessRange * (Float.parseFloat(sourceGraph.getLabelText(e)) - (float) minW);
				// if (Float.parseFloat(sourceGraph.getLabelText(ec.edge())) <=
				// edgeRelevancePercentageThreshold) continue;
				// if ((Double.parseDouble(sourceGraph.getLabelText(ec.edge()))
				// < edgeRelevancePercentageThreshold *
				// nodeToInWeight.get(currentSource)) ||
				// (Double.parseDouble(sourceGraph.getLabelText(ec.edge())) <
				// edgeRelevancePercentageThreshold *
				// nodeToInWeight.get(currentTarget))) {
				// if ((Double.parseDouble(sourceGraph.getLabelText(ec.edge()))
				// < edgeRelevanceAbsoluteThreshold)) {
				// if ( Math.pow
				// (Double.parseDouble(sourceGraph.getLabelText(ec.edge())),2.0)
				// < minIncidentNodeCard * edgeRelevancePercentageThreshold) {
				// tooThin = true; }

			} else { // unweightedPfusch
				if (nodeToSphere.get(currentSource).getRadius() < nodeToSphere.get(currentTarget).getRadius())
					currentEdgeThickness = nodeToSphere.get(currentSource).getRadius();
				else
					currentEdgeThickness = nodeToSphere.get(currentTarget).getRadius();
				currentEdgeThickness *= 0.3f;
			}

			if (!tooThin)
				objRoot.addChild(placeEdge(e, currentEdgeThickness, currentSource, currentTarget));
		}
	}

	private float spaceOnEdge(Edge edge) {
		float space = 0.0f;
		Vector3f sourceLoc = nodeToLocation.get(edge.source());
		Vector3f targetLoc = nodeToLocation.get(edge.target());
		Vector3f v = new Vector3f(-sourceLoc.x + targetLoc.x, -sourceLoc.y + targetLoc.y, -sourceLoc.z + targetLoc.z);
		space = v.length();
		space -= nodeToSphere.get(edge.source()).getRadius();
		space -= nodeToSphere.get(edge.source()).getRadius();
		return (space);
	}

	private javax.media.j3d.Node placeEdge(Edge theEdge, float thickness, Node source, Node target) {
		Vector3f sourceLoc = nodeToLocation.get(source);
		Vector3f targetLoc = nodeToLocation.get(target);
		Vector3f v = new Vector3f(-sourceLoc.x + targetLoc.x, -sourceLoc.y + targetLoc.y, -sourceLoc.z + targetLoc.z);
		float length = (float) v.length();

		Appearance edgeAppearance = new Appearance();
		edgeColoringAttributes.setShadeModel(ColoringAttributes.NICEST);
		edgeAppearance.setColoringAttributes(edgeColoringAttributes);
		edgeAppearance.setMaterial(edgeMaterial);

		Cylinder cylinder = new Cylinder(thickness, length, edgeAppearance);
		TransformGroup TG = new TransformGroup();
		Transform3D T3D = new Transform3D();
		Vector3f Translation = new Vector3f(0.5f * (sourceLoc.x + targetLoc.x), 0.5f * (sourceLoc.y + targetLoc.y), 0.5f * (sourceLoc.z + targetLoc.z));

		Vector3f RotAxis = new Vector3f(0.0f, 1.0f, 0.0f);
		// System.out.println(RotAxis);
		// System.out.println(v);
		float RotAngle = (float) Math.acos((RotAxis.dot(v) / (v.length() * RotAxis.length())));
		RotAxis.cross(RotAxis, v);
		// System.out.println(RotAxis+" "+RotAngle);
		AxisAngle4f Rotation = new AxisAngle4f(RotAxis.x, RotAxis.y, RotAxis.z, RotAngle);

		if (graphIsDirected) { // Pfeilspitze bauen und auch ausrichten
			// if (restrictArrowCones && (spaceOnEdge(theEdge) >= thickness *
			// 6.0f)) {
			if (!((Graph2D) theEdge.getGraph()).getLabelText(target).split("_")[0].equals(((Graph2D) theEdge.getGraph()).getLabelText(source).split("_")[0])) {
				Cone edgeCone = new Cone(thickness * 3.0f, thickness * 6.0f, edgeAppearance);
				TransformGroup TGCone = new TransformGroup();
				Transform3D T3DCone = new Transform3D();
				Vector3f translationOfCone = new Vector3f(v);
				translationOfCone.scale(0.5f);
				T3DCone.setTranslation(translationOfCone);
				// TGCone.setTransform(T3DCone);
				TGCone.addChild(edgeCone);
				TG.addChild(TGCone);
				// add the cone to Map
				edgeToCone.put(theEdge, edgeCone);
			}
		}

		T3D.setTranslation(Translation);
		T3D.setRotation(Rotation);
		TG.setTransform(T3D);
		TG.addChild(cylinder);
		// add the cylinder to Map
		TG.setPickable(false);
		edgeToCylinder.put(theEdge, cylinder);
		return TG;
	}

	private void createCoordinateSystem(BranchGroup objRoot) {
		float axisRadius = 0.2f;
		float xAxisLength = tubeLength + 10.0f;
		float axisLength = 2f * tubeRadius + 5.0f;
		float axisConeLength = 1.0f;
		float axisConeRadius = 0.5f;
		float axisTranslation = tubeRadius + 3f;

		Appearance axisAppearance = new Appearance();
		axisAppearance.setMaterial(axisMaterial);
		axisColoringAttributes.setShadeModel(ColoringAttributes.NICEST);
		axisAppearance.setColoringAttributes(axisColoringAttributes);

		Cylinder xAxis = new Cylinder(axisRadius, xAxisLength, axisAppearance);
		Cylinder yAxis = new Cylinder(axisRadius, axisLength, axisAppearance);
		Cylinder zAxis = new Cylinder(axisRadius, axisLength, axisAppearance);
		TransformGroup xAxisTG = new TransformGroup();
		TransformGroup yAxisTG = new TransformGroup();
		TransformGroup zAxisTG = new TransformGroup();
		Transform3D xAxisTrans3D = new Transform3D();
		Transform3D yAxisTrans3D = new Transform3D();
		Transform3D zAxisTrans3D = new Transform3D();
		Vector3f xAxisPosition = new Vector3f(0.0f, -1f * axisTranslation, -1f * axisTranslation);
		Vector3f yAxisPosition = new Vector3f(-1f * xAxisLength / 2f, (float) (axisLength / 2.0 - axisTranslation), -1f * axisTranslation);
		Vector3f zAxisPosition = new Vector3f(-1f * xAxisLength / 2f, -1f * axisTranslation, (float) (axisLength / 2.0 - axisTranslation));
		xAxisTrans3D.setTranslation(xAxisPosition);
		yAxisTrans3D.setTranslation(yAxisPosition);
		zAxisTrans3D.setTranslation(zAxisPosition);
		xAxisTrans3D.setRotation(new AxisAngle4d(0, 0, 1, Math.PI / 2.0));
		yAxisTrans3D.setRotation(new AxisAngle4d(0, 0, 0, 0)); // no rotation
		zAxisTrans3D.setRotation(new AxisAngle4d(1, 0, 0, Math.PI / 2.0));
		xAxisTG.setTransform(xAxisTrans3D);
		yAxisTG.setTransform(yAxisTrans3D);
		zAxisTG.setTransform(zAxisTrans3D);
		xAxisTG.addChild(xAxis);
		yAxisTG.addChild(yAxis);
		zAxisTG.addChild(zAxis);
		objRoot.addChild(xAxisTG);
		objRoot.addChild(yAxisTG);
		objRoot.addChild(zAxisTG);

		Sphere theOrigin = new Sphere(axisRadius * 1.5f);
		TransformGroup originTG = new TransformGroup();
		Transform3D originTrans3D = new Transform3D();
		Vector3f originPosition = new Vector3f(-1f * xAxisLength / 2f, -1f * axisTranslation, -1f * axisTranslation);
		originTrans3D.setTranslation(originPosition);
		originTG.setTransform(originTrans3D);
		originTG.addChild(theOrigin);
		objRoot.addChild(originTG);
		pickAppearance.addScope(theOrigin);

		Cone xAxisCone = new Cone(axisConeRadius, axisConeLength, axisAppearance);
		Cone yAxisCone = new Cone(axisConeRadius, axisConeLength, axisAppearance);
		Cone zAxisCone = new Cone(axisConeRadius, axisConeLength, axisAppearance);
		TransformGroup xAxisConeTG = new TransformGroup();
		TransformGroup yAxisConeTG = new TransformGroup();
		TransformGroup zAxisConeTG = new TransformGroup();
		Transform3D xAxisConeTrans3D = new Transform3D();
		Transform3D yAxisConeTrans3D = new Transform3D();
		Transform3D zAxisConeTrans3D = new Transform3D();
		Vector3f xAxisConePosition = new Vector3f(xAxisLength / 2.0f + axisConeLength / 2.0f, -1f * axisTranslation, -1f * axisTranslation);
		Vector3f yAxisConePosition = new Vector3f(-1f * xAxisLength / 2f, (float) (axisLength - axisTranslation) + axisConeLength / 2.0f, -1f * axisTranslation);
		Vector3f zAxisConePosition = new Vector3f(-1f * xAxisLength / 2f, -1f * axisTranslation, (float) (axisLength - axisTranslation) + axisConeLength / 2.0f);
		xAxisConeTrans3D.setTranslation(xAxisConePosition);
		yAxisConeTrans3D.setTranslation(yAxisConePosition);
		zAxisConeTrans3D.setTranslation(zAxisConePosition);
		xAxisConeTrans3D.setRotation(new AxisAngle4d(0, 0, -1, Math.PI / 2.0));
		yAxisConeTrans3D.setRotation(new AxisAngle4d(0, 0, 0, 0)); // no
		// rotation
		zAxisConeTrans3D.setRotation(new AxisAngle4d(1, 0, 0, Math.PI / 2.0));
		xAxisConeTG.setTransform(xAxisConeTrans3D);
		yAxisConeTG.setTransform(yAxisConeTrans3D);
		zAxisConeTG.setTransform(zAxisConeTrans3D);
		xAxisConeTG.addChild(xAxisCone);
		yAxisConeTG.addChild(yAxisCone);
		zAxisConeTG.addChild(zAxisCone);
		objRoot.addChild(xAxisConeTG);
		objRoot.addChild(yAxisConeTG);
		objRoot.addChild(zAxisConeTG);
	}

	private void createLight(BranchGroup objRoot) {
		// Set up the ambient light
		BoundingSphere lightBounds = new BoundingSphere(new Point3d(10.0, 10.0, 10.0), 200.0);
		Color3f ambientColor = new Color3f(1.0f, 1.0f, 1.0f);
		AmbientLight ambientLightNode = new AmbientLight(ambientColor);
		ambientLightNode.setInfluencingBounds(lightBounds);
		// objRoot.addChild(ambientLightNode);

		/* Set up the directional lights */
		Color3f light1Color = orange;
		Vector3f light1Direction = new Vector3f(-1.0f, -1.0f, -1.0f);
		DirectionalLight light1 = new DirectionalLight(light1Color, light1Direction);
		light1.setInfluencingBounds(lightBounds);
		objRoot.addChild(light1);

		Color3f light2Color = yellow;
		Vector3f light2Direction = new Vector3f(1.0f, 0.2f, 0.2f);
		DirectionalLight light2 = new DirectionalLight(light2Color, light2Direction);
		light2.setInfluencingBounds(lightBounds);
		objRoot.addChild(light2);

		Color3f light3Color = red;
		Vector3f light3Direction = new Vector3f(0.2f, 1.0f, 0.2f);
		DirectionalLight light3 = new DirectionalLight(light3Color, light3Direction);
		light3.setInfluencingBounds(lightBounds);
		objRoot.addChild(light3);

		Color3f light4Color = blue;
		Vector3f light4Direction = new Vector3f(0.2f, 0.2f, 1.0f);
		DirectionalLight light4 = new DirectionalLight(light4Color, light4Direction);
		light4.setInfluencingBounds(lightBounds);
		objRoot.addChild(light4);

	}

	private void createBaseTube(BranchGroup objRoot) {

		Appearance tubeAppearance = new Appearance();

		// Set up the texture map
		TextureLoader textureLoader = new TextureLoader(FlyThroughGenreTime.class.getResource("resource/famousHeads/adult.jpg"), "LUMINANCE", new Container());
		Texture texture = textureLoader.getTexture();
		texture.setBoundaryModeS(Texture.WRAP);
		texture.setBoundaryModeT(Texture.WRAP);
		texture.setBoundaryColor(new Color4f(0.0f, 1.0f, 0.0f, 0.0f));
		// Set up the texture attributes
		// could be REPLACE, BLEND or DECAL instead of MODULATE
		TextureAttributes texAttr = new TextureAttributes();
		texAttr.setTextureMode(TextureAttributes.MODULATE);
		if (tubeTextureOn) {
			tubeAppearance.setTexture(texture);
			tubeAppearance.setTextureAttributes(texAttr);
		}

		// set up Transparency
		TransparencyAttributes transAttr = new TransparencyAttributes(TransparencyAttributes.BLENDED, (float) tubeTransparency, TransparencyAttributes.BLEND_SRC_ALPHA, TransparencyAttributes.BLEND_SRC_ALPHA);
		tubeAppearance.setTransparencyAttributes(transAttr);

		// set up the material
		tubeColoringAttributes.setShadeModel(ColoringAttributes.NICEST);
		tubeAppearance.setColoringAttributes(tubeColoringAttributes);
		tubeAppearance.setMaterial(tubeMaterial);

		int tubePrimflags = Primitive.GENERATE_NORMALS + Primitive.GENERATE_TEXTURE_COORDS;

		Cylinder theTube = new Cylinder(tubeRadius, tubeLength, tubePrimflags, tubeAppearance);
		TransformGroup tubeTransGroup = new TransformGroup();
		Transform3D tubeTrans3D = new Transform3D();
		Vector3f tubePosition = new Vector3f(.0f, .0f, .0f); // center of
		// tube is the
		// origin of the
		// REAL
		// coordinate
		// system!
		tubeTrans3D.setTranslation(tubePosition);
		tubeTrans3D.setRotation(new AxisAngle4d(0, 0, 1, Math.PI / 2.0)); // rotate
		// arouund
		// z-Axis
		// by
		// 90
		// degree
		tubeTransGroup.setTransform(tubeTrans3D);
		tubeTransGroup.addChild(theTube);
		theTube.setPickable(false);
		objRoot.addChild(tubeTransGroup);
	}

	public FlyThroughGenreTime() {
		setTitle("Fly Through GenreTime");
		setSize(new Dimension(600, 400));
		// MainFrame mf = new MainFrame(fh, resolutionX, resolutionY);
		setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setLayout(new BorderLayout());
		// addKeyListener(this);

		GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
		c3d = new Canvas3D(config);
		canvasTopLeft = c3d.getLocationOnScreen();
		c3d.setDoubleBufferEnable(true);
		c3d.addMouseMotionListener(this);
		c3d.addKeyListener(this);
		c3d.addMouseListener(this);
		c3d.addMouseWheelListener(this);
		c3d.setMinimumSize(new Dimension(600, 400));
		addComponentListener(new ComponentAdapter() {

			@Override
			public void componentResized(ComponentEvent e) {
				super.componentResized(e);
				// Component c3d = e.getComponent();
				if (c3d == null)
					return;
				resolutionY = c3d.getHeight();
				resolutionX = c3d.getWidth();
				refX = canvasTopLeft.getX() + resolutionX / 2.0;
				refY = canvasTopLeft.getY() + resolutionY / 2.0;
			}

			@Override
			public void componentMoved(ComponentEvent e) {
				super.componentMoved(e);
				// Component c3d = e.getComponent();
				canvasTopLeft = c3d.getLocationOnScreen();
				refX = canvasTopLeft.getX() + resolutionX / 2.0;
				refY = canvasTopLeft.getY() + resolutionY / 2.0;
			}
		});

		add(c3d, BorderLayout.CENTER);

		timer = new Timer(timerMillis, this);
		currentPressedKey = KeyEvent.VK_UNDEFINED;        
		// timer.start();

		JPanel buttons = new JPanel();
		go.setPreferredSize(invertMouseY.getPreferredSize());
		buttons.add(go);
		buttons.add(invertMouseY);
		// buttons.add(steuerknueppelButton);

		messageLabel.setHorizontalAlignment(SwingConstants.CENTER);

		JPanel statusbar = new JPanel(new BorderLayout());
		statusbar.add(buttons, BorderLayout.LINE_START);
		statusbar.add(messageLabel, BorderLayout.CENTER);
		statusbar.add(coordLabel, BorderLayout.LINE_END);
		add(statusbar, BorderLayout.PAGE_END);

		go.addActionListener(this);
		go.addKeyListener(this);
		invertMouseY.addActionListener(this);
		invertMouseY.addKeyListener(this);
		if (steuerKnueppelMode) {
			lookSensitivity *= knueppelSensitivity;
		}
		// Create a simple scene and attach it to the virtual universe
		scene = createSceneGraph();

		// -----------------------------------------------------------FIRERAY------------------------------------------------------------
		dynamicParentGroup = new BranchGroup();
		dynamicParentGroup.setCapability(Group.ALLOW_CHILDREN_READ);
		dynamicParentGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
		dynamicParentGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
		dynamicStuffBG = new BranchGroup();
		dynamicStuffBG.setCapability(BranchGroup.ALLOW_DETACH);
		// dynamicParentGroup.addChild(dynamicStuffBG);
		// scene.addChild(dynamicParentGroup);
		// set up fire ray zeug
		fireRay = new Cylinder(0.05f, 100.0f);
		TGFire = new TransformGroup();
		TGFireSub = new TransformGroup();
		TGFire.setCapability(BranchGroup.ALLOW_DETACH);
		T3DFire = new Transform3D();
		T3DFireSub = new Transform3D();
		TGFire.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		AxisAngle4f FireRayPreRotation = new AxisAngle4f(-1.0f, .0f, .0f, (float) (Math.PI / 2.0));
		Vector3f FireRayPreTranslation = new Vector3f(.0f, -0.2f, 0.0f);
		T3DFireSub.setRotation(FireRayPreRotation);
		T3DFireSub.setTranslation(FireRayPreTranslation);
		TGFireSub.setTransform(T3DFireSub);
		TGFireSub.addChild(fireRay);
		TGFire.addChild(TGFireSub);
		dynamicStuffBG.addChild(TGFire);
		Appearance fireRayAppearance = new Appearance();
		fireRayColoringAttributes.setShadeModel(ColoringAttributes.NICEST);
		fireRayAppearance.setColoringAttributes(fireRayColoringAttributes);
		fireRayAppearance.setMaterial(fireRayMaterial);
		// -----------------------------------------------------------FIRERAYEND---------------------------------------------------------

		// picking
		pickCanvas = new PickCanvas(c3d, scene);
		pickCanvas.setMode(PickCanvas.BOUNDS);

		// create the universe
		SimpleUniverse u = new SimpleUniverse(c3d);
		u.addBranchGraph(scene);

		// set up moving camera
		vPlatform = u.getViewingPlatform();
		vPlatform.setNominalViewingTransform();
		flyingCamera = vPlatform.getViewPlatformTransform();
		moveCamera.setTranslation(startPosition);
		moveCamera.setRotation(startRotation);
		flyingCamera.setTransform(moveCamera);
		u.getViewer().getView().setBackClipDistance(100.0);
	}

	private void rotMatReset() {
		rotMatX.set(unitMatrix3D);
		rotMatY.set(unitMatrix3D);
		rotMatZ.set(unitMatrix3D);
	}

	public void keyPressed(KeyEvent e) {
		// Invoked when a key has been pressed.
		if (e.getKeyChar() == 'r') { // reset everything (position, heading,
			// movement)!!
			resetPosAndHeading();
		}
		else if (e.getKeyChar() == 'n') {
			printCameraStats();
		} 
		else if (e.getKeyChar() == 't') {
			tourPlay();
			tourCounter = 0;
			playOn = !playOn;
			try {
				if (playOn) {
					statsRead = new BufferedReader(new FileReader(navFile));
				} else
					statsRead.close();
			} catch (IOException ioe) {
			}
		}

		else if (e.getKeyChar() == 'z') {
			tourRecord();
		}

		else if (e.getKeyChar() == 'y') { // invert up-down-look,
			// arcade<->simulator
			Ysign *= -1.0;
		}

		else if ((e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER) && (!timer.isRunning())) {
			timer.start();
			resetPosAndHeading();
		} else if (currentPressedKey == KeyEvent.VK_UNDEFINED) {
			currentPressedKey = e.getKeyCode();
		}

	}

	public void keyEvaluation(int keyNumber) {
		// X-Axis (left - right(pos))
		if (keyNumber == KeyEvent.VK_S) {
			camHeading.getColumn(0, dazuPosition);
			dazuPosition.scale(-1.0 * moveSensitivity);
			camPosition.add(dazuPosition);
		} else if (keyNumber == KeyEvent.VK_F) {
			camHeading.getColumn(0, dazuPosition);
			dazuPosition.scale(moveSensitivity);
			camPosition.add(dazuPosition);
		}

		// Y-Axis (up(pos) - down)
		else if (keyNumber == java.awt.event.KeyEvent.VK_SPACE) {
			camHeading.getColumn(1, dazuPosition);
			dazuPosition.scale(-1.0 * moveSensitivity);
			camPosition.add(dazuPosition);
		} else if (keyNumber == KeyEvent.VK_LESS) {
			camHeading.getColumn(1, dazuPosition);
			dazuPosition.scale(moveSensitivity);
			camPosition.add(dazuPosition);
		}

		// Z-Axis (outOfScreen(pos) - intoScreen)
		else if (keyNumber == KeyEvent.VK_E) {// forward
			camHeading.getColumn(2, dazuPosition);
			dazuPosition.scale(-1.0 * moveSensitivity);
			camPosition.add(dazuPosition);
		} else if (keyNumber == KeyEvent.VK_D) {// backward
			camHeading.getColumn(2, dazuPosition);
			dazuPosition.scale(moveSensitivity);
			camPosition.add(dazuPosition);
		}

		// Turn Left and Right around camera-Y-axis
		else if (keyNumber == KeyEvent.VK_J) {// left
			cosmY = Math.cos(lookSensitivity * -1.0 * keyRollFactor); // Eigentlich
			sinmY = Math.sin(lookSensitivity * -1.0 * keyRollFactor); // nur
			rotMatY.setColumn(0, cosmY, 0.0, sinmY);
			rotMatY.setColumn(2, -sinmY, 0.0, cosmY);
			camHeading.mul(rotMatY);
			rotMatReset();
		} else if (keyNumber == KeyEvent.VK_L) { // KeyEvent.VK_KP_RIGHT geht irgendwie
			// ned
			cosmY = Math.cos(lookSensitivity * 1.0 * keyRollFactor);
			sinmY = Math.sin(lookSensitivity * 1.0 * keyRollFactor);
			rotMatY.setColumn(0, cosmY, 0.0, sinmY);
			rotMatY.setColumn(2, -sinmY, 0.0, cosmY);
			camHeading.mul(rotMatY);
			rotMatReset();
		}

		// Turn Up and Down around camera-X-axis
		else if (keyNumber == KeyEvent.VK_I) { // up
			cosmX = Math.cos(lookSensitivity * -1.0 * keyRollFactor);
			sinmX = Math.sin(lookSensitivity * -1.0 * keyRollFactor);
			rotMatX.setColumn(1, 0.0, cosmX, -sinmX);
			rotMatX.setColumn(2, 0.0, sinmX, cosmX);
			camHeading.mul(rotMatX);
			rotMatReset();
		} else if (keyNumber == KeyEvent.VK_K) { // down
			cosmX = Math.cos(lookSensitivity * 1.0 * keyRollFactor);
			sinmX = Math.sin(lookSensitivity * 1.0 * keyRollFactor);
			rotMatX.setColumn(1, 0.0, cosmX, -sinmX);
			rotMatX.setColumn(2, 0.0, sinmX, cosmX);
			camHeading.mul(rotMatX);
			rotMatReset();
		}

		// Roll Left and Right around camera-Z-axis
		else if (keyNumber == KeyEvent.VK_U) { // roll left
			cosmZ = Math.cos(lookSensitivity * 1.0 * keyRollFactor);
			sinmZ = Math.sin(lookSensitivity * 1.0 * keyRollFactor);
			rotMatZ.setColumn(0, cosmZ, sinmZ, 0.0);
			rotMatZ.setColumn(1, -sinmZ, cosmZ, 0.0);
			camHeading.mul(rotMatZ);
			rotMatReset();
		} else if (keyNumber == KeyEvent.VK_O) { // roll right
			cosmZ = Math.cos(lookSensitivity * -1.0 * keyRollFactor);
			sinmZ = Math.sin(lookSensitivity * -1.0 * keyRollFactor);
			rotMatZ.setColumn(0, cosmZ, sinmZ, 0.0);
			rotMatZ.setColumn(1, -sinmZ, cosmZ, 0.0);
			camHeading.mul(rotMatZ);
			rotMatReset();
		}
	}

	private void addStatsToNavFile() {
		try {
			statsWrite.newLine();
			// statsWrite.append(timer.toString());
			statsWrite.newLine();
			statsWrite.append(camHeading.toString());
			statsWrite.append(camPosition.toString());
			// statsWrite.newLine();
		} catch (IOException e) {
			System.err.println("HILFEEEEEEEEEEE");
		}
		;
	}

	private void initializeNavFile() {
		try {
			statsWrite = new BufferedWriter(new FileWriter(navFile));
		}
		// statsWrite.write("# This is a navigation file for a tour");
		catch (IOException e) {
			System.err.println("HILFEEEEEEEEEEE");
		}
		;
	}

	private void tourRecord() {
		recordOn = !recordOn;
		if (recordOn) {
			// timer.restart();
			initializeNavFile();
		} else {
			try {
				statsWrite.close();
			} catch (IOException e) {
				System.err.println("HILFEEEEEEEEEEE");
			}
			;
		}

		// resetPosAndHeading();
		// theRobot.delay(100);
		// theRobot.keyPress(KeyEvent.VK_E);
		// theRobot.delay(3000);
		// theRobot.keyPress(java.awt.event.KeyEvent.VK_O);
		// theRobot.delay(2000);
		// theRobot.keyRelease(java.awt.event.KeyEvent.VK_E);
		// theRobot.keyRelease(java.awt.event.KeyEvent.VK_O);
		// theRobot.mouseMove((int)refX-30 , (int)refY+10);
		// theRobot.keyPress(java.awt.event.KeyEvent.VK_S);
		// theRobot.delay(5000);
	}

	private void tourPlay() {
	}

	public void resetPosAndHeading() {
		// int x = resolutionX / 2;
		// int y = resolutionY / 2;
		// camHeading.set(startRotation);
		camHeading.set(startRotation);
		camPosition.set(startPosition);
		theRobot.mouseMove(((int) refX), ((int) refY) + 10);
		rotMatReset();
		// System.out.println(refX + " " + refY + 10);
	}

	public void keyReleased(KeyEvent e) {
		if (currentPressedKey == e.getKeyCode())
			currentPressedKey = KeyEvent.VK_UNDEFINED;
	}

	public void keyTyped(KeyEvent e) {
		// Invoked when a key has been typed.
	}

	public void actionPerformed(ActionEvent e) {
		// start timer when button is pressed
		if ((e.getSource() == go) && (!timer.isRunning())) {
			timer.start();
			resetPosAndHeading();
		}

		rotation += 0.1;
		if (rotation > 2.0 * Math.PI)
			rotation -= 2.0 * Math.PI;
		for (HeadSet currentHeadSet : allHeads) {
			currentHeadSet.headPostRotation.set(tempRotAxis, currentHeadSet.rotSpeed * (float) rotation);
			currentHeadSet.headPostTrans3D.setRotation(currentHeadSet.headPostRotation);
			currentHeadSet.headPostTransGroup.setTransform(currentHeadSet.headPostTrans3D);
		}

		keyEvaluation(currentPressedKey);

		if (steuerKnueppelMode) {
			try {
				if (!rotateTheViewer()) {
					playOn = false;
					statsRead.close();
				}
			} catch (IOException ioe) {
			}
		} else {
			moveCamera.setRotation(camHeading);
		}

		if (!playOn) {
			moveCamera.setTranslation(camPosition);
			flyingCamera.setTransform(moveCamera);
		}

		//T3DFire.setTranslation(new Vector3f((float) camPosition.x, (float) camPosition.y, (float) camPosition.z));
		//TGFire.setTransform(T3DFire);

		if (e.getSource() == invertMouseY) {
			Ysign *= -1.0;
		}
		if (e.getSource() == cameraInfo) {
			printCameraStats();
		}
		// if (e.getSource() == steuerknueppelButton) {
		// steuerKnueppelMode = !steuerKnueppelMode;
		// if (steuerKnueppelMode) {
		// lookSensitivity *= knueppelSensitivity;
		// refX = resolutionX / 2.0;
		// refY = resolutionY / 2.0;
		// } else {
		// lookSensitivity /= knueppelSensitivity;
		// resetPosAndHeading();
		// }
		// }
	}

	public boolean rotateTheViewer() throws IOException {
		if (playOn) {
			if (statsRead != null) {
				String line = "";
				while (line != null && line.length() == 0) {
					line = statsRead.readLine();
				}
				if (line != null) {
					for (int i = 0; i < 3; ++i) {
						System.out.println("> " + line);
						StringTokenizer tokens = new StringTokenizer(line, " ,");
						int j = -1;
						while (j < 3 && tokens.hasMoreTokens()) {
							camHeading.setElement(i, ++j, Double.parseDouble(tokens.nextToken()));
						}
						line = statsRead.readLine();
					}
					System.out.println(camHeading + "\n");
					System.out.println("> " + line);
					StringTokenizer tokens = new StringTokenizer(line, " ,()");
					int j = -1;
					double myVect[] = new double[3];
					while (j < 3 && tokens.hasMoreTokens()) {
						myVect[++j] = Double.parseDouble(tokens.nextToken());
					}
					System.out.println(new Vector3d(myVect));
					camPosition.set(new Vector3d(myVect));
					statsRead.readLine();
				} else
					return false;
			}
			moveCamera.setTranslation(camPosition);
		} else {
			camHeading.mul(rotMatX);
			camHeading.mul(rotMatY);
		}

		moveCamera.setRotation(camHeading);
		flyingCamera.setTransform(moveCamera);

		if (recordOn)
			addStatsToNavFile();
		return true;
	}

	public void mouseDragged(MouseEvent m) {
		Point mousePoint = m.getPoint();
		Vector2d aim = new Vector2d(mousePoint.x - refX, mousePoint.y - refY);
		if (aim.length() < aimTolerance)
			aim.set(0.0, 0.0);
		else
			aim.scale(1 - (aimTolerance / aim.length()));

		// mX = (double) m.getY() - refY;
		mX = aim.y;
		mY = aim.x;

		mX *= Ysign; // Flugsimulator invertMouse
		cosmX = Math.cos(lookSensitivity * mX);
		sinmX = Math.sin(lookSensitivity * mX);
		rotMatX.setColumn(1, 0.0, cosmX, -sinmX);
		rotMatX.setColumn(2, 0.0, sinmX, cosmX);

		// mY = (double) m.getX() - refX;
		cosmY = Math.cos(lookSensitivity * mY);
		sinmY = Math.sin(lookSensitivity * mY);
		rotMatY.setColumn(0, cosmY, 0.0, sinmY);
		rotMatY.setColumn(2, -sinmY, 0.0, cosmY);

		if (!steuerKnueppelMode) {
			refY = (double) m.getY(); // alt = neu
			refX = (double) m.getX();
			try {
				rotateTheViewer();
			} catch (IOException ioe) {
			}
		}

		T3DFire.setRotation(camHeading);
		TGFire.setTransform(T3DFire);
	}

	public void mouseMoved(MouseEvent m) {
		Point mousePoint = m.getPoint();
		Vector2d aim = new Vector2d(mousePoint.x + canvasTopLeft.getX() - refX, mousePoint.y + canvasTopLeft.getY() - refY);
		if (aim.length() < aimTolerance)
			aim.set(0.0, 0.0);
		else
			aim.scale(1 - (aimTolerance / aim.length()));

		// mX = (double) m.getY() - refY;
		mX = aim.y;
		mY = aim.x;

		mX *= Ysign; // Flugsimulator invertMouse
		cosmX = Math.cos(lookSensitivity * mX);
		sinmX = Math.sin(lookSensitivity * mX);
		rotMatX.setColumn(1, 0.0, cosmX, -sinmX);
		rotMatX.setColumn(2, 0.0, sinmX, cosmX);

		// mY = (double) m.getX() - refX;
		cosmY = Math.cos(lookSensitivity * mY);
		sinmY = Math.sin(lookSensitivity * mY);
		rotMatY.setColumn(0, cosmY, 0.0, sinmY);
		rotMatY.setColumn(2, -sinmY, 0.0, cosmY);

		if (!steuerKnueppelMode) {
			refY = (double) m.getY(); // alt = neu
			refX = (double) m.getX();
			try {
				rotateTheViewer();
			} catch (IOException ioe) {
			}
		}

		coordLabel.setText("Position: " + printVector(camPosition, 2, 1) + "   Heading: " + printVector((new Vector3d(camHeading.m02, camHeading.m12, camHeading.m22)), 1, 2));
	}

	private String printVector(Vector3d vec, int decDig, int fracDig) {
		StringBuffer s = new StringBuffer(15);
		NumberFormat nf = new DecimalFormat();
		nf.setMaximumFractionDigits(fracDig);
		nf.setMinimumFractionDigits(fracDig);
		nf.setMaximumIntegerDigits(decDig);
		nf.setMinimumIntegerDigits(decDig);
		s.append(nf.format(vec.x)).append(' ');
		s.append(nf.format(vec.y)).append(' ');
		s.append(nf.format(vec.z));
		return s.toString();
	}

	public void mouseClicked(MouseEvent m) {
	}

	public void printCameraStats() {
		System.out.println("----------------------------------------------------------------------------");
		System.out.print("Camera heads: \n" + camHeading);
		System.out.println("Camera sits at: " + camPosition);
		System.out.println();
	}

	public void mousePressed(MouseEvent m) {
		pickCanvas.setShapeLocation(m);
		PickResult result = pickCanvas.pickClosest();
		if (result == null) {
			System.out.println("Nothing picked");
		} else {
			Primitive p = (Primitive) result.getNode(PickResult.PRIMITIVE);
			Shape3D s = (Shape3D) result.getNode(PickResult.SHAPE3D);
			Node pickedNode = sphereToNode.get(p);
			if (p != null) {
				messageLabel.setText("Picked Node: " + pickedNode);
				// System.out.println(p.getClass().getName());
				// p.setAppearance(boomAppearance);
				pickAppearance.addScope(p);
				// System.out.println(pickAppearance.numScopes());
			} else if (s != null) {
				// System.out.println(s.getClass().getName());
				messageLabel.setText("Nothing Picked");
			} else {
				System.out.println("null");
			}
		}

		T3DFire.setRotation(camHeading);
		T3DFire.setTranslation(new Vector3f((float) camPosition.x, (float) camPosition.y, (float) camPosition.z - 0.01f));
		TGFire.setTransform(T3DFire);
		dynamicParentGroup.addChild(dynamicStuffBG);
	}

	public void mouseReleased(MouseEvent m) {
		dynamicStuffBG.detach();
	}

	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public void mouseWheelMoved(MouseWheelEvent e) {
		mZ = (double) e.getWheelRotation();
		cosmZ = Math.cos(lookSensitivity * mZ * mWheelRollFactor);
		sinmZ = Math.sin(lookSensitivity * mZ * mWheelRollFactor);
		rotMatZ.setColumn(0, cosmZ, sinmZ, 0.0);
		rotMatZ.setColumn(1, -sinmZ, cosmZ, 0.0);

		camHeading.mul(rotMatZ);
		moveCamera.setRotation(camHeading);
		flyingCamera.setTransform(moveCamera);
	}

	public static void main(String[] args) {
		System.out.println("Program Started");
		FlyThroughGenreTime fh = new FlyThroughGenreTime();
		fh.addKeyListener(fh);
		try {
			theRobot = new Robot();
		} catch (AWTException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		fh.setVisible(true);
	}
}